-- thread.lua for threadTest.love

------------------------------
-- add required Love functions
------------------------------
require 'love.filesystem'
require 'love.timer'
d3	= require 'Ref3D'
com = require 'Communicate'
pi, sin, cos	= math.pi, math.sin, math.cos
gr, lt, le		= love.graphics, love.timer, love.event

function load()
	-------------------
	-- create thread --
	-------------------
	com.createBackgroundThread()
	-----------------------
	-- set initial state --
	-----------------------
	tstate = 1
	-----------------
	-- load points --
	-----------------
	points, _ = d3.loadData( 'teapot.r3d' )
	end

function update()
	if tstate == 1 then
		lt.sleep( 0.005 )		-- helps smooth out rotation & reduces CPU usage
		local success	= com.thread.getData()
		if success then
			deltaAngle	= success
			tstate		= 2
			end
		end
	if tstate == 2 then
		lt.sleep( 0.005 )		-- helps smooth out rotation & reduces CPU usage
		newPoints	= processPoints()
		success		= com.thread.sendData(newPoints)
		if success then tstate = 1 end
		end
	end

function processPoints()		-- rotate points and place in string for transmission
	local strPoints = ''
	for i = 1, #points do
		points[i][2],points[i][3] = d3.func.rotateX(points[i][2],points[i][3], deltaAngle,0,0)
		points[i][1],points[i][3] = d3.func.rotateY(points[i][1],points[i][3],-deltaAngle,0,0)
		strPoints=strPoints..points[i][1]..','..points[i][2]..','..points[i][3]..','
		end
	return strPoints
	end

load()
-----------------------------------------------------------
-- after loading, loop continuously until thread stopped --
-----------------------------------------------------------
while bkgnd:peek( 'thread' ) == 'running'  do update() end

